import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by thook on 10/7/15.
 */
public class HamletParser {

    private String hamletData;

    public HamletParser(){
        this.hamletData = loadFile();
    }

    private String loadFile(){
        ClassLoader classLoader = getClass().getClassLoader();
        File file = new File(classLoader.getResource("hamlet.txt").getFile());
        StringBuilder result = new StringBuilder("");

        try(Scanner scanner = new Scanner(file)){
            while(scanner.hasNextLine()){
                String line = scanner.nextLine();
                result.append(line).append("\n");
            }

            scanner.close();
        }catch(IOException e){
            e.printStackTrace();
        }

        return result.toString();
    }



    public String getHamletData(){
        return hamletData;
    }





    public String changedHamletToLeon(){


        String replaceHamlet = "";

        replaceHamlet = hamletData.replaceAll("(?i)Hamlet", "Leon");


        return replaceHamlet;
    }





    public String changeHoratioToTariq(){

        String replacedHoratio = "";

        replacedHoratio = hamletData.replaceAll("(?i)Horatio", "Tariq");

        return replacedHoratio;
    }





    public int findHamletOccurances(){

        Pattern pattern = Pattern.compile("(?i)Hamlet");
        Matcher matcher = pattern.matcher(hamletData);

        int counter = 0;

        while(matcher.find()){
            counter++;
        }

        return counter;
    }



    public int findHoratioOccurances(){

        Pattern pattern = Pattern.compile("(?i)Horatio");
        Matcher matcher = pattern.matcher(hamletData);

        int counter = 0;

        while(matcher.find()){
            counter++;
        }

        return counter;
    }





}
